/* TEST.C ******************************************************************/
/* Program przykladowy pokazujacy sposob wykorzystania driver'ow modulow   */
/* serii LC-011 i LC-020 firmy AMBEX.                                      */
/***************************************************************************/
/* Program zostal przygotowany do kompilacji w kazdym modelu pamieci       */
/* (wymuszenie dalekich adresow przesylanych do driver'a).                 */
/* W katalogu zawierajacym standardowe naglowki C musi sie znajdowac plik  */
/* AMBEX-LC.H.                                                             */
/* UWAGA: Przed rozpoczeciem kompilacji nalezy sprawdzic ustawienie opcji  */
/*        kompilatora:                                                     */
/*              - alingment = byte,                                        */
/*              - default char type = signed.                              */
/***************************************************************************/

#include "ambex-lc.h"		/* struktury danych i definicje stalych do */
				/* komunikacji z driver'em                 */
#include <conio.h>		/* funkcja getch                           */
#include <dos.h>		/* funkcja int86                           */
#include <io.h>			/* dla funkcji driverinstalled             */
#include <stdio.h>		/* wyswietlanie                            */
#include <stdlib.h>		/* funkcja exit                            */
#include <alloc.h>		/* alokacja bufora dla funkcji sinewrite() */
#include <math.h>		/* definicja sin() w funkcji sinewrite()   */
#include <mem.h>		/* funkcja memset			   */
#include <bios.h>
/******************** deklaracje procedur **********************************/
void	askdriver(void);
void	blocktransmission(void);
void	checkdrivers(void);
void	displaybuf(int *buf, int c, int s);
void	performcalc(int *calc_buf, int c, int s);
void	displayconfiguration(void);
void	drivererror(char status, char err_stat);
int	driverinstalled(char *name);
void	failblocktransmission(void);
void	installbreak(void);
void	interruptedafter(void);
void	interruptedbefore(void);
void	pressanykey(void);
void	quit(void);
void	singletransmission(void);
void	asynchrtransmission(void);
void	asynchrtransmission1(void);
void 	a_interrupt_service(void);
void 	a1_interrupt_service(void);
void	cycletransmission(void);
void 	c_interrupt_service(void);
void	transmission(unsigned char start);
void 	singlewrite(void);
void 	sinewrite(void);
void interrupt my_break(void);

/******************** definicje stalych ************************************/
#define	TRUE		1
#define	FALSE		0
#define	BUFLEN		(8 * 20)		/* dlugosc bufora          */
#define	SAMPLES		20			/* liczba probek           */
#define	CHANNELS	8			/* liczba kanalow          */

/******************** deklaracje zmiennych *********************************/
int	LCinterrupt;		/* numer przerwania driver'a               */
				/* rekordy opisu poszczegolnych zlecen     */
struct	lc0_init		s_init        = {MODULE_INIT};
struct	lc0_total		s_total       = {GET_TOTAL_CONFIGURATION};
struct	lc0_module		s_module      = {GET_MODULE_CONFIGURATION};
struct	lc0_info		s_info        = {GET_INFO};
struct	lc0_break		s_break       = {BREAK};
struct	lc0_analog_in		s_analog_in   = {ANALOG_INPUT};
struct	lc0_analog_out		s_analog_out  = {ANALOG_OUTPUT};
struct	lc0_leave		s_leave       = {LEAVE_DRIVER};
struct	lc0_interrupt		s_interr      = {INTERRUPT_SERVICE};
union	REGS	r;		/* parametr dla funkcji int86              */
int	modulenum;		/* numer badanego modulu                   */
int	koniec = 0;
int	bufnum = 0;
int	huge *buf1;
int	huge *buf2;
int	sstat;                  /* slowo komunikacyjne dla funkcji obslugi */
				/* przerwania z modulu                     */

				/* ------- teksty bledow                   */
char	*DriverErrors[] =
{
						/* LC0_UNKN_FUNC	-1 */
"LC0_UNKN_FUNC: Nieznany kod funkcji",
						/* LC0_NO_MODULE	-2 */
"LC0_NO_MODULE: Bledny numer modulu",
						/* LC0_BAD_DEV_TYP	-3 */
"LC0_BAD_DEV_TYP: Brak urzadzen danego typu",
						/* LC0_NONEX_DEV	-4 */
"LC0_NONEX_DEV: Bledny numer urzadzenia",
						/* LC0_BAD_FREQ		-5 */
"LC0_BAD_FREQ: Bledny okres",
						/* LC0_BAD_RANGE	-6 */
"LC0_BAD_RANGE: Bledny zakres napiec",
						/* LC0_NO_OPER		-7 */
"LC0_NO_OPER: Brak operacji w toku",
						/* LC0_BAD_MARGIN	-8 */
"LC0_BAD_MARGIN: Bledna dlugosc marginesu poczatkowego",
						/* LC0_BAD_BUF_ADR	-9 */
"LC0_BAD_BUF_ADR: Bledny adres bufora",
						/* LC0_BAD_BUF_LEN     -10 */
"LC0_BAD_BUF_LEN: Bledna dlugosc bufora",
						/* LC0_DEV_BUSY	       -11 */
"LC0_DEV_BUSY: Urzadzenie zajete",
						/* LC0_BAD_PER	       -12 */
"LC0_BAD_PER: Za krotki okres probkowania",
						/* LC0_BAD_CHAN_N      -13 */
"LC0_BAD_CHAN_N: Bledna liczba kanalow",
						/* LC0_BAD_CHAN	       -14 */
"LC0_BAD_CHAN: Bledny numer kanalu",
						/* LC0_BROKEN 	       -15 */
"LC0_BROKEN: Przetwarzanie przerwane funkcja BREAK",
						/* LC0_INTR_NOT_INST   -16 */
"LC0_INTR_INST: Procedura obslugi przerwania nie jest zainstalowana",
						/* LC0_ILL_START_CODE  -17 */
"LC0_ILL_START_CODE: Nielegalny sposob startu",
						/* LC0_ILL_STOP_CODE   -18 */
"LC0_ILL_STOP_CODE: Nielegalny sposob stopu",
						/* LC0_BAD_PROC	       -19 */
"LC0_BAD_PROC: Bledny adres procedury obslugi przerwania",
						/* LC0_TOO_LONG_MARG   -20 */
"LC0_TOO_LONG_MARG: Za dlugi margines poczatkowy",
						/* LC0_ILL_START       -21 */
"LC0_ILL_START: Bledne parametry warunku startu",
						/* LC0_ILL_STOP	       -22 */
"LC0_ILL_STOP: Bledne parametry warunku stopu",
						/* LC0_BAD_MNUM	       -23 */
"LC0_BAD_MNUM: Bledny numer pierwszej probki",
						/* LC0_NOT_SUPPORTED   -24 */
"LC0_NOT_SUPPORTED: Funkcja nie jest realizowana",
						/* LC0_BAD_CTC_MODE    -25 */
"LC0_BAD_CTC_MODE: Bledny tryb pracy CTC",
						/* LC0_NO_PARAMS       -26 */
"LC0_NO_PARAMS: Nie podano parametrow przetwarzania",
						/* LC0_OVERRUN	       -27 */
"LC0_OVERRUN: Blad OVERRUN",
						/* LC0_NO_DMA	       -28 */
"LC0_NO_DMA: Urzadzenie nie jest podlaczone do DMA",
						/* LC0_NO_IRQ	       -29 */
"LC0_NO_IRQ: Z modulem nie jest zwiazane zadne przerwanie",
						/* LC0_NOT_FULLY_SUP   -30 */
"LC0_NOT_FULLY_SUP: Funkcja w opracowaniu",
						/* LC0_NO_EXTMEM       -31 */
"LC0_NO_EXTMEM: Brak pamieci dodatkowej",
						/* LC0_NO_SEC_FREQ     -32 */
"LC0_NO_SEC_FREQ: Modul ma tylko jedna czestotliwosc",
						/* LC0_INTR_INST       -33 */
"LC0_INTR_INST: Procedura obslugi przerwania juz zainstalowana",
						/* LC0_BAD_PER2	       -34 */
"LC0_BAD_PER2: Bledna wielokrotnosc okresu probkowania",
						/* LC0_BAD_MODE	       -35 */
"LC0_BAD_MODE: Bledny tryb pracy",
						/* LC0_BAD_EXTMEM      -36 */
"LC0_BAD_EXTMEM: Bledny adres bufora w pamieci rozszerzonej",
						/* LC0_NOT_PROGRAMMED  -37 */
"LC0_CTC_NOT_PROGRAMMED: Zapis licznika przy niezaprogramowanym trybie pracy",
						/* LC0_REJECTED	       -38 */
"LC0_REJECTED: Za duzo jednoczesnych odwolan do driver'a",
};

				/* ------ teksty ostrzezen                */
char	*DriverWarnings[] =
{
						/* LC0_NON_EX_MOD	1 */
"LC0_NON_EX_MOD: Zazadano inicjalizacji nieistniejacych modulow",
						/* LC0_OTHER_LEN	2 */
"LC0_OTHER_LEN: Przepisano mniej probek niz zazadano",
						/* LC0_PREMATURE_END	3 */
"LC0_PREMATURE_END: Zakonczenie operacji z powodu przepelnienia bufora",
						/* LC0_IN_PROGRESS      4 */
"LC0_IN_PROGRESS: Badana transmisja jeszcze trwa",
};

				/* ------- teksty informacji dodatkowych  */
char	*DriverAdditionalErrors[] =
{
						/* LC0_E_NO_MODULE	-1 */
"LC0_E_NO_MODULE: Nie ma takiego modulu",
						/* LC0_E_NONEX_DEV	-2 */
"LC0_E_NONEX_DEV: Nie istnieje urzadzenie o tym numerze",
						/* LC0_E_BAD_CHAN	-3 */
"LC0_E_BAD_CHAN: Numer nieistniejacego kanalu",
						/* LC0_E_BAD_TIME	-4 */
"LC0_E_BAD_TIME: Zly odcinek czasu",
						/* LC0_E_BAD_DATE	-5 */
"LC0_E_BAD_DATE: Zla specyfikacja daty",
						/* LC0_E_BAD_THRE	-6 */
"LC0_E_BAD_THRE: Bledny prog wyzwalania analogowego",
						/* LC0_E_BROKEN_WAIT	-7 */
"LC0_E_BROKEN_WAIT: Przerwanie w trakcie oczekiwania na warunek startu",
						/* LC0_E_BROKEN_RUN	-8 */
"LC0_E_BROKEN_RUN: Przerwanie w trakcie przetwarzania",
						/* LC0_E_BAD_LEN        -9 */
"LC0_E_BAD_LEN: Zadeklarowano za duzo probek",
};

/***************************************************************************/
/***************************************************************************/
void main(void)
{
	checkdrivers();		/* rozpoznanie zainstalowanego driver'a    */
	askdriver();		/* odpytanie driver'a o konfiguracje       */
	displayconfiguration();	/* wyswietlenie konfiguracji modulu i      */
				/* toru a/c                                */
	installbreak();		/* zainstalowanie procedury obslugi        */
				/* przerwania generowanego przez Ctrl-Break*/
	pressanykey();		/* oczekiwanie na operatora                */

	blocktransmission();	/* wykonanie transmisji blokowej +         */
				/* wyswietlenie zmierzonych wartosci       */
	failblocktransmission();/* wykonanie blednej transmisji blokowej   */
	interruptedbefore();	/* wykonanie transmisji blokowej przerwanej*/
				/* przez operatora przed startem           */
	interruptedafter();	/* wykonanie transmisji blokowej przerwanej*/
				/* przez operatora po starcie              */
	singletransmission();	/* wykonanie pomiaru w trybie pojedynczym  */

	asynchrtransmission();  /* wykonanie pomiaru w trybie              */
				/* asynchronicznym		           */

	asynchrtransmission1();  /* wykonanie pomiaru w trybie              */
				/* asynchronicznym		           */
	cycletransmission();	/* wykonanie pomiaru w trybie              */
				/* asynchronicznym - praca z buforem       */
				/*                   cyklicznym            */
	singlewrite();          /* zapis wartosci na przetwornik CA        */
	sinewrite();		/* zapis przebiegu sinusoidalnego na CA    */
	quit();			/* zakonczenie programu                    */
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Rozpoznanie, ktory driver (a co za tym idzie ktory modul) jest        */
/*   zainstalowany.                                                        */
/* Sposob:                                                                 */
/*   Przez sprawdzenie zainstalowania kazdego z potencjalnych driver'ow.   */
/* Uwagi:                                                                  */
/*   Funkcja dodatkowo wyswietla komunikat o testowanym module i podstawia */
/*   wlasciwa wartosc na zmienna LCinterrupt (wlasciwy numer przerwania    */
/*   driver'a). Jezeli zaden driver nie jest zainstalowany to po           */
/*   wyswietleniu wlasciwego komunikaru program konczy prace.              */
/***************************************************************************/
void checkdrivers(void)
{
	clrscr();
	gotoxy(1, 1);
	if(driverinstalled("LC1116^^"))
	    {
	    printf("Test modulu LC-011-1612\n");
	    LCinterrupt = LC011_16;
	    }
	else if(driverinstalled("LC2008^2"))
	    {
	    printf("Test modulu LC-020-0812\n");
	    LCinterrupt = LC020_08_2;
	    }
	else if(driverinstalled("LC2032^^"))
	    {
	    printf("Test modulu LC-020_3212\n");
	    LCinterrupt = LC020_32;
	    }
	else
	    {
	    printf("Driver nie jest zainstalowany!\n");
	    exit(1);
	    }
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Sprawdzenie obecnosci drivera.                                        */
/* Sposob:                                                                 */
/*   Przez probe otwarcia urzadzenia o nazwie okreslonej przez driver.     */
/* Parametry:                                                              */
/*   name - nazwa urzadzenia                                               */
/* Wartosc:                                                                */
/*   TRUE  - driver jest zainstalowany                                     */
/*   FALSE - driver nie jest zainstalowany                                 */
/***************************************************************************/
int driverinstalled(char *name)
{
	int	hd;

	hd = open(name, 0);
	if(hd == -1)
	    return(FALSE);
	else
	    {
	    close(hd);
	    return(TRUE);
	    }
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Rozpoznanie konfiguracji badanego modulu.                             */
/* Sposob:                                                                 */
/*   Przez wykorzystanie funkcji driver'a GET_TOTAL_CONFIGURATION,         */
/*   GET_MODULE_CONFIGURATION, GET_INFO.                                   */
/* Uwagi:                                                                  */
/*   Funkcja nadaje wartosc zmiennej modulenum (numer badanego modulu)     */
/*   wypelnia struktury total, module, info i inicjalizuje zainstalowane   */
/*    moduly.                                                              */
/***************************************************************************/
void askdriver(void)
{
	r.x.dx = FP_SEG(&s_total);
	r.x.di = FP_OFF(&s_total);
	int86(LCinterrupt, &r, &r);		/* GET_TOTAL_CONFIGURATION */

				/* inicjalizacja zainstalowanych modulow   */
	s_init.LC0_IMODULE = s_total.LC0_TONF & 0xF;
	r.x.dx = FP_SEG(&s_init);
	r.x.di = FP_OFF(&s_init);
	int86(LCinterrupt, &r, &r);			/* MODULE_INIT     */

					/* sprawdzenie, ktory modul jest   */
					/*   zainstalowany: A, B, C czy D  */
	for(modulenum = 1; modulenum <= 4; modulenum++)
	    if(s_total.LC0_TONF & (1 << (modulenum - 1)))
		break;

					/* spytanie o konfiguracje modulu  */
	s_module.LC0_MMODULE = modulenum;
	r.x.dx = FP_SEG(&s_module);
	r.x.di = FP_OFF(&s_module);
	int86(LCinterrupt, &r, &r);		/* GET_MODULE_CONFIGURATION*/

					/* spytanie o konfiguracje toru a/c*/
	s_info.LC0_GMODULE = modulenum;
	s_info.LC0_GTYPE   = LC0_AINPUT;
	s_info.LC0_GNUM    = 1;
	r.x.dx = FP_SEG(&s_info);
	r.x.di = FP_OFF(&s_info);
	int86(LCinterrupt, &r, &r);			/* GET_INFO        */
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wyswietlenie konfiguracji badanego modulu i jego toru a/c.            */
/* Sposob:                                                                 */
/*   Przez wykorzystanie informacji zawartych w strukturach module i info. */
/***************************************************************************/
void displayconfiguration(void)
{
	int	i;
					/* konfiguracja modulu             */
	printf("\n---------- Konfiguracja modulu:\n\n");
	printf("Adres modulu: %04X (hex)\n", s_module.LC0_MBASE1);
	printf("Liczba przetwornikow a/c: %d\n", s_module.LC0_MIAD);
	printf("Liczba przetwornikow c/a: %d\n", s_module.LC0_MIDA);
	printf("Liczba portow cyfrowych wejsciowych: %d\n",
		s_module.LC0_MIDI);
	printf("Liczba portow cyfrowych wyjsciowych: %d\n",
		s_module.LC0_MIDO);
	printf("Czestotliwosc zegara modulu: %d MHz\n",
						s_module.LC0_MCLOCK / 1000);

					/* konfiguracja toru a/c           */
	printf("\n---------- Konfiguracja toru a/c:\n\n");
	printf("Liczba kanalow: %d\n", s_info.LC0_GCHAN);
	printf("Rozdzielczosc: %d bitow\n", s_info.LC0_GRES);
	printf("Zakres napiec: %.1f..%.1f V\n",
		(float)s_info.LC0_GMINV / 10,
		(float)s_info.LC0_GMAXV / 10);
	if(s_info.LC0_GDMA == 0xFF)
	    printf("Tor a/c nie jest podlaczony do kanalow DMA\n");
	else
	    printf("Numer kanalu DMA podlaczonego do toru a/c: %d\n",
							    s_info.LC0_GDMA);
	printf("Minimalne okresy probkowania [s]:\n");
	printf("     ");
	for(i = 0; i < s_info.LC0_GCHAN; i++)
	    {
	    printf("%.1f", (float)s_info.LC0_GMINP[i] / 10);
	    if(i < s_info.LC0_GCHAN - 1)
		{
		printf(", ");
		if((i + 1) % 8 == 0)
		    {
		    printf("\n");	/* zlamanie linii co 8 wielkosci   */
		    printf("     ");
		    }
		}
	    }
	printf("\n");
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Procedura obslugi przerwania Ctrl-Break.                              */
/* Sposob:                                                                 */
/*   Przez wywolanie funkcji BREAK.                                        */
/***************************************************************************/
void interrupt my_break(void)
{
	static union REGS r;

	koniec = 1;

	s_break.LC0_BMODE = LC0_BREAK_EXEC;
	r.x.dx = FP_SEG(&s_break);
	r.x.di = FP_OFF(&s_break);
	int86(LCinterrupt, &r, &r);			/* BREAK           */
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Zainstalowanie procedury obslugi przerwania generowanego przez        */
/*   Ctrl-Break.                                                           */
/* Sposob:                                                                 */
/*   Przez wywolanie funkcji BREAK.                                        */
/***************************************************************************/
void installbreak(void)
{
	s_break.LC0_BMODE = LC0_BREAK_INST;
	s_break.LC0_BPROC = my_break;		/* podlozona zostanie      */
						/*   procedura driver'a    */
	r.x.dx = FP_SEG(&s_break);
	r.x.di = FP_OFF(&s_break);
	int86(LCinterrupt, &r, &r);			/* BREAK           */
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Przerwa miedzy kolejnymi czesciami programu - oczekiwanie na reakcje  */
/*   operatora.                                                            */
/***************************************************************************/
void pressanykey(void)
{
	printf("\nNacisnij dowolny klawisz . . .");
	getch();
	clrscr();
	gotoxy(1, 1);
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wykonanie poprawnej transmisji blokowej i wyswietlenie zmierzonych    */
/*   wartosci.                                                             */
/* Sposob:                                                                 */
/*   Przez wykonanie funkcji transmission.                                 */
/***************************************************************************/
void blocktransmission(void)
{
	printf("---------- Poprawne przetwarzanie blokowe\n\n");
	s_analog_in.LC0_APER = (long)s_info.LC0_GMINP[CHANNELS - 1];
	transmission(LC0_SIMMED);
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wykonanie blednej transmisji blokowej.                                */
/* Sposob:                                                                 */
/*   Przez wykonanie funkcji ANALOG_INPUT z okresem probkowania mniejszym  */
/*   niz minimalny wskazany przez driver.                                  */
/***************************************************************************/
void failblocktransmission(void)
{
	printf("---------- Bledne przetwarzanie blokowe\n\n");
	s_analog_in.LC0_APER = (long)s_info.LC0_GMINP[CHANNELS - 1] - 1;
	transmission(LC0_SIMMED);
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wykonanie poprawnej transmisji blokowej ale przerwanej przez operatora*/
/*   (Ctrl-Break) w trakcie czekania na spelnienie warunku startu.         */
/* Sposob:                                                                 */
/*   Przez wykonanie funkcji ANALOG_INPUT z warunkiem startu LC0_STIME     */
/*   (start po okreslonym czasie) i parametrem tego warunku - 1000s.       */
/***************************************************************************/
void interruptedbefore(void)
{
	printf("---------- Przetwarzanie blokowe z oczekiwaniem 1000s\n");
	printf("---------- Oczekiwanie nalezy przerwac Ctrl-Break\n\n");
	s_analog_in.LC0_APER = (long)s_info.LC0_GMINP[CHANNELS - 1];
	s_analog_in.LC0_ASTART.time = 1000;
	transmission(LC0_STIME);
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wykonanie poprawnej transmisji blokowej ale przerwanej przez operatora*/
/*   (Ctrl-Break) w trakcie pomiaru.                                       */
/* Sposob:                                                                 */
/*   Przez wykonanie funkcji ANALOG_INPUT z okresem probkowania 100s.      */
/***************************************************************************/
void interruptedafter(void)
{
	printf("---------- Przetwarzanie blokowe ",
	       "z okresem probkowania 100s\n");
	printf("---------- Pomiar nalezy przerwac Ctrl-Break\n\n");
	s_analog_in.LC0_APER = 1000000000L;
	transmission(LC0_SIMMED);
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wykonanie pomiaru bloku probek za pomoca tranmsisji pojedynczej, przy */
/*   czym caly blok ma byc zmierzony po 10s od startu.                     */
/* Sposob:                                                                 */
/*   Przez wykonanie funkcji ANALOG_INPUT.                                 */
/* Parametry:                                                              */
/* Wartosc:                                                                */
/* Uwagi:                                                                  */
/***************************************************************************/
void singletransmission(void)
{
	int	buf[BUFLEN];		/* bufor na probki                 */
	int	i,
		j;

	printf("---------- Przetwarzanie pojedyncze - po 5 sekundach\n\n");
	s_analog_in.LC0_AMODULE = modulenum;
	s_analog_in.LC0_ANUM = 1;
	s_analog_in.LC0_AMODE = LC0_MOD_START |
			      LC0_MOD_NEW_PAR |
			      LC0_MOD_SYNCHR;
				/* praca wielokanalowa, CHANNELS kanalow   */
	s_analog_in.LC0_ACHAN = CHANNELS;
	s_analog_in.LC0_AADDR = (int far *)buf; /* konieczna konwersja na  */
						/*   daleki adres          */
	s_analog_in.LC0_ALEN = CHANNELS;	/* dlugosc bufora (tylko   */
						/*   na jeden pomiar)      */
	s_analog_in.LC0_ASTST = LC0_STIME;
	s_analog_in.LC0_ASTART.time = 5;	/* start po 5 sekundach    */
	r.x.dx = FP_SEG(&s_analog_in);
	r.x.di = FP_OFF(&s_analog_in);
	int86(LCinterrupt, &r, &r);			/* ANALOG_INPUT    */
	s_analog_in.LC0_ASTST = LC0_SIMMED;
	i = 1;
	s_analog_in.LC0_AADDR = (int far *)&buf[i++ * CHANNELS];
	r.x.dx = FP_SEG(&s_analog_in);
	r.x.di = FP_OFF(&s_analog_in);
	int86(LCinterrupt, &r, &r);			/* ANALOG_INPUT    */
	s_analog_in.LC0_AMODE &= ~LC0_MOD_NEW_PAR;	/* zgaszenie bitu  */
							/* LC0_MOD_NEW_PAR */
	for(j = 0; j < 18; j++)
	    {
	    s_analog_in.LC0_AADDR = (int far *)&buf[i++ * CHANNELS];
	    r.x.dx = FP_SEG(&s_analog_in);
	    r.x.di = FP_OFF(&s_analog_in);
	    int86(LCinterrupt, &r, &r);			/* ANALOG_INPUT    */
	    }
	displaybuf(buf, CHANNELS, SAMPLES);
	pressanykey();
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wykonanie transmisji blokowej.                                        */
/* Sposob:                                                                 */
/*   Przez wykonanie funkcji ANALOG_INPUT.                                 */
/* Parametry:                                                              */
/*   start - typ warunku startu                                            */
/* Wartosc:                                                                */
/* Uwagi:                                                                  */
/*   Funkcja wywolujaca musi ustawic okres probkowania i parametry warunku */
/*   startu.                                                               */
/***************************************************************************/
void transmission(unsigned char start)
{
	int	buf[BUFLEN];

	printf
	(
	"Pomiar blokowy, %d kanalow, %d probek, okres probkowania %.1f s:\n",
	CHANNELS, SAMPLES, (float)s_analog_in.LC0_APER / 10
	);
	switch(start)
	    {
	    case LC0_SIMMED:
		printf("Warunek startu: natychmiast\n");
		break;
	    case LC0_STIME:
		printf("Warunek startu: uplyw %lu sekund\n",
						s_analog_in.LC0_ASTART.time);
		break;
				/* pozostale warunki nie sa obslugiwane bo */
				/*   w programie nie sa wykorzystywane     */
	    }
	s_analog_in.LC0_AMODULE = modulenum;
	s_analog_in.LC0_ANUM = 1;
	s_analog_in.LC0_AMODE = LC0_MOD_START |
			      LC0_MOD_NEW_PAR |
			      LC0_MOD_SYNCHR |
			      LC0_MOD_BLOCK;
			/* stop po zmierzeniu okreslonej liczby probek     */
	s_analog_in.LC0_ASTST = start + LC0_ZSAMPLES;
				/* praca wielokanalowa, CHANNELS kanalow   */
	s_analog_in.LC0_ACHAN = CHANNELS;
	s_analog_in.LC0_AADDR = (int far *)buf;	/* konieczna konwersja na  */
						/*   daleki adres          */
	s_analog_in.LC0_ALEN = BUFLEN;	/* dlugosc bufora                  */
	s_analog_in.LC0_ABMAR = 0;
	s_analog_in.LC0_AEMAR = 0;	/* oba marginesy zerowe            */
					/* calkowita liczba probek         */
	s_analog_in.LC0_ASTOP.samples = SAMPLES * CHANNELS;
	r.x.dx = FP_SEG(&s_analog_in);
	r.x.di = FP_OFF(&s_analog_in);
	int86(LCinterrupt, &r, &r);			/* ANALOG_INPUT    */
	if(s_analog_in.LC0_STATUS != LC0_OK)
	    drivererror(s_analog_in.LC0_STATUS, s_analog_in.LC0_ERR_STAT);
	else
	    displaybuf(buf, CHANNELS, SAMPLES);
	pressanykey();
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wyswietlenie bufora z danymi pomiarowymi.                             */
/* Parametry:                                                              */
/*   buf - adres bufora                                                    */
/*   c   - liczba kanalow                                                  */
/*   s   - liczba probek na kanal                                          */
/***************************************************************************/
void displaybuf(int *buf, int c, int s)
{
	int	i,
		j;

	gotoxy(1,5);
	for(i = 0; i < s; i++)
	    {
	    printf("%2d: ", i + 1);
	    for(j = 0; j < c; j++)
				printf("%04X  ", buf[i * c + j]);
	    printf("\n");
	    }
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wykonanie obliczen w czasie pomiaru do drugiego bufora.               */
/* Parametry:                                                              */
/*   calc_buf - adres bufora przetwarzanego                                */
/*   c   - liczba kanalow                                                  */
/*   s   - liczba probek na kanal                                          */
/***************************************************************************/
void	performcalc(int *calc_buf, int c, int s)
{
	int	i,
		j;
	unsigned int avrege[CHANNELS];

	for(i = 0; i < c; i++)		/* zerowanie wektora srednich */
		avrege[i] = 0;

	for(i = 0; i < s; i++)				/* liczenie sredniej w kanalach */
		 for(j = 0; j < c; j++)
			avrege[j] += calc_buf[i * c + j];
	for(j = 0; j < c; j++)
		avrege[j] /= s;

	gotoxy(1,4);
	printf("Praca z dwoma buforami\n");
	gotoxy(1,7);
	printf("Srednie w poszczegolnych kanalach bufora do obliczen:\n");
	for(j = 0; j < c; j++)
		printf("%04X  ", avrege[j]);
	printf("\n\n      Czekamy na zakoczenie pomiaru do drugiego bufora ...");

	do
		;
	while(!koniec);
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wypisanie komunikatow o bledzie / ostrzezeniu / dodatkowej informacji */
/*   bledzie.                                                              */
/* Parametry:                                                              */
/*   status   - LC0_STATUS                                                 */
/*   err_stat - LC0_ERR_STAT                                               */
/***************************************************************************/
void drivererror(char status, char err_stat)
{
	if(status > 0)
	    printf("--------- Ostrzezenie:\n%s\n",
	    	   DriverWarnings[status - 1]);
	else
	    printf("--------- Blad:\n%s\n", DriverErrors[-status - 1]);
	if(err_stat < 0)
	    printf("--------- Informacje dodatkowe:\n%s\n",
		   DriverAdditionalErrors[-err_stat - 1]);
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Zakonczenie pracy programu.                                           */
/* Sposob:                                                                 */
/*   Przez wykonanie funkcji exit. Wczesniej - rozstanie sie z driver'em za*/
/*   pomoca funkcji LEAVE_DRIVER.                                          */
/***************************************************************************/
void quit(void)
{
	r.x.dx = FP_SEG(&s_leave);
	r.x.di = FP_OFF(&s_leave);
	int86(LCinterrupt, &r, &r);			/* LEAVE_DRIVER    */

	printf("Dziekuje, to wszystko!\n");
	exit(0);
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wyslanie pojedynczej wartosci na przetwornik CA                       */
/* Sposob:                                                                 */
/*   Przez wykonanie funkcji ANALOG_OUTPUT.                                */
/* Parametry:                                                              */
/* Wartosc:                                                                */
/* Uwagi:                                                                  */
/***************************************************************************/
void singlewrite(void)
{
	int	val[2];			/* wartosc do wyslania             */

	printf("---------- Wyslanie pojedynczej wartosci na przetwornik CA\n\n");
	if(!s_module.LC0_MIDA)
	{
		printf("---------- Karta nie posiada zainstalowanych przetwornikow CA\n\n");
		pressanykey();
		return;
	}

	val[0] = 4095;
	s_analog_out.LC0_NMODULE = modulenum;
	s_analog_out.LC0_NNUM = 1;
	s_analog_out.LC0_NMODE = LC0_MOD_START |
				 LC0_MOD_NEW_PAR |
				 LC0_MOD_SYNCHR;
					/* praca jednokanalowa             */
	s_analog_out.LC0_NCHAN = 1 + 128;
	s_analog_out.LC0_NADDR.base_memory = (int far *)val; /* konieczna konwersja na */
						/*   daleki adres          */
	s_analog_out.LC0_NLEN = 1;		/* dlugosc bufora (tylko   */
						/*   na jedna wartosc)     */
	s_analog_out.LC0_NSTST = LC0_SIMMED;
	r.x.dx = FP_SEG(&s_analog_out);
	r.x.di = FP_OFF(&s_analog_out);
	int86(LCinterrupt, &r, &r);			/* ANALOG_OUTPUT    */
	pressanykey();
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wykonanie przebiegu sinusoidalnego na przetwornik CA.                 */
/* Sposob:                                                                 */
/*   Przez wykonanie funkcji ANALOG_OUTPUT.                                */
/* Parametry:                                                              */
/* Wartosc:                                                                */
/* Uwagi:                                                                  */
/***************************************************************************/
#define DACBUF 65536L
#define _2PI  6.28318

void sinewrite(void)
{
	long		DAC_BUFLEN;
	unsigned int 	seg, last;
	int huge 	*DacBuffer;
	int far  	*Buffer_to_free;
	float		k, LowWave, UpWave, PerWave, Period;
	int		i, j, range;


	if(!s_module.LC0_MIDA)
	{
		printf("---------- Wyslanie na przetwornik CA przebiegu sinusoidalnego\n\n");
		printf("---------- Karta nie posiada zainstalowanych przetwornikow CA\n\n");
		pressanykey();
		return;
	}
	DAC_BUFLEN = DACBUF / sizeof(int);
	if((DacBuffer = (int huge *)farmalloc(2L * DAC_BUFLEN * sizeof(int))) == NULL)
	  {
	  printf("BLAD - brak pamieci");
	  return;
	  }
	Buffer_to_free = (int far *)DacBuffer;
	seg = FP_SEG((int far *)DacBuffer) + 1;
	last = seg + (DAC_BUFLEN * sizeof(int)) / 16;
	if((seg & 0xf000) != (last & 0xf000))
	DacBuffer = (int huge *)MK_FP((last & 0xf000), 0);

					/* spytanie o konfiguracje toru c/a*/
	s_info.LC0_GMODULE = modulenum;
	s_info.LC0_GTYPE   = LC0_AOUTPUT;
	s_info.LC0_GNUM    = 1;
	r.x.dx = FP_SEG(&s_info);
	r.x.di = FP_OFF(&s_info);
	int86(LCinterrupt, &r, &r);		/* GET_INFO        */

	range = (s_info.LC0_GMAXV - s_info.LC0_GMINV)/10;
	k = (float)((1 << s_info.LC0_GRES) - 1) / range;
					/* PARAMETRY PRZEBIEGU             */
	LowWave = s_info.LC0_GMINV/10;	/* dolna wartosc przebiegu [V]     */
	UpWave  = s_info.LC0_GMAXV/10;  /* gorna wartosc przebiegu [V]     */
	PerWave = 10.0;                 /* okres przebiegu [ms]            */
	Period  = 0.1;          	/* okres wysylania [ms]            */


	printf("---------- Wyslanie na przetwornik CA przebiegu sinusoidalnego\n\n");
	printf("---------- Wysylanie mozna przerwac Ctrl-Break\n\n");


	for(i = 0, j = PerWave/Period; i < (int)(PerWave/Period); i ++)
	    DacBuffer[i] = ((UpWave - LowWave) / 2 * sin(i * _2PI / j) + range / 2) * k;

	s_analog_out.LC0_NMODULE = modulenum;
	s_analog_out.LC0_NNUM = 1;
	s_analog_out.LC0_NMODE = LC0_MOD_START |
			      LC0_MOD_NEW_PAR |
			      LC0_MOD_SYNCHR |
			      LC0_MOD_BLOCK |
			      LC0_MOD_CYCL;
			/* praca cykliczna, stop po wcisnieciu Ctrl-Break  */
	s_analog_out.LC0_NSTST = LC0_SIMMED + LC0_ZSAMPLES;
						/* praca jednokanalowa     */
	s_analog_out.LC0_NCHAN = 1 + 128;
	s_analog_out.LC0_NADDR.base_memory = (int far *)DacBuffer;
					/* konieczna konwersja na          */
					/*   daleki adres                  */
	s_analog_out.LC0_NLEN  = DAC_BUFLEN;	/* dlugosc bufora          */
					/* calkowita liczba probek         */
	s_analog_out.LC0_NSTOP.samples = (PerWave/Period);
	s_analog_out.LC0_NPER  = (unsigned long)(Period * 10000.0);
	r.x.dx = FP_SEG(&s_analog_out);
	r.x.di = FP_OFF(&s_analog_out);
	int86(LCinterrupt, &r, &r);			/* ANALOG_OUTPUT   */
	farfree(Buffer_to_free);

}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wykonanie asynchronicznej transmisji blokowej.                        */
/* Sposob:                                                                 */
/*   Przez wykonanie funkcji ANALOG_INPUT.                                 */
/* Parametry:                                                              */
/* Wartosc:                                                                */
/* Uwagi:                                                                  */
/***************************************************************************/
#define	BUFLEN1	32768L
void asynchrtransmission(void)
{
	unsigned int 	seg, last;
	int far  	*Buffer_to_free;


	if((buf1 = (int huge *)farmalloc(2*BUFLEN1 * sizeof(int))) == NULL)
	  {
	  printf("BLAD - brak pamieci");
	  return;
	  }
	Buffer_to_free = (int far *)buf1;
	seg = FP_SEG((int far *)buf1) + 1;
	last = seg + (BUFLEN1 * sizeof(int)) / 16;
	if((seg & 0xf000) != (last & 0xf000))
	  buf1 = (int huge *)MK_FP((last & 0xf000), 0);

			/* wyinstalowanie obslugi przerwania z modulu */
	s_interr.LC0_SMODULE = 1;
	s_interr.LC0_SPROC = NULL;
	sstat = 0;
	s_interr.LC0_SSTAT = &sstat;
	r.x.dx = FP_SEG(&s_interr);
	r.x.di = FP_OFF(&s_interr);
	int86(LCinterrupt, &r, &r);

			/* zainstalowanie obslugi przerwania z modulu */
	s_interr.LC0_SMODULE = 1;
	s_interr.LC0_SPROC = a_interrupt_service;
	r.x.dx = FP_SEG(&s_interr);
	r.x.di = FP_OFF(&s_interr);
	int86(LCinterrupt, &r, &r);	/* INTERRUPT SERVICE */



	memset((void *)buf1, 0xFF, BUFLEN * sizeof(int));
	s_analog_in.LC0_APER = 5000000L;
	printf
	(
	"Pomiar blokowy, %d kanalow, %d probek, okres probkowania %.1f s:\n",
	CHANNELS, SAMPLES, (float)s_analog_in.LC0_APER / 10
	);
	s_analog_in.LC0_AMODULE = modulenum;
	s_analog_in.LC0_ANUM = 1;
	s_analog_in.LC0_AMODE = LC0_MOD_START |
			      LC0_MOD_NEW_PAR |
			      LC0_MOD_INTR |
			      LC0_MOD_BLOCK;
			/* stop po zmierzeniu okreslonej liczby probek     */
	s_analog_in.LC0_ASTST = LC0_ZSAMPLES;
				/* praca wielokanalowa, CHANNELS kanalow   */
	s_analog_in.LC0_ACHAN = CHANNELS;
	s_analog_in.LC0_AADDR = (int far *)buf1;/* konieczna konwersja na  */
						/*   daleki adres          */
	s_analog_in.LC0_ALEN = BUFLEN;	/* dlugosc bufora                  */
	s_analog_in.LC0_ABMAR = 0;
	s_analog_in.LC0_AEMAR = 0;	/* oba marginesy zerowe            */
					/* calkowita liczba probek         */
	s_analog_in.LC0_ASTOP.samples = SAMPLES * CHANNELS;
	r.x.dx = FP_SEG(&s_analog_in);
	r.x.di = FP_OFF(&s_analog_in);
	int86(LCinterrupt, &r, &r);			/* ANALOG_INPUT    */
	koniec = 0;
	do
	   displaybuf((int *)buf1, CHANNELS, SAMPLES);
	while(!koniec);
	koniec = 0;
	pressanykey();
	farfree(Buffer_to_free);

}
/****************************************************************************/
/* Przeznaczenie:                                                           */
/*   Obsluga przerwania przychodzacego z modulu po zmierzeniu bloku         */
/*   probek - praca asynchroniczna z przerwaniem na koniec bloku            */
/* Sposob:                                                                  */
/* Parametry:                                                               */
/* Wartosc:                                                                 */
/* Uwagi:                                                                   */
/****************************************************************************/
#define	ATONE	500	/* parametry sygnalu informujacego o koncu bloku    */
void a_interrupt_service(void)
{
	static unsigned int	a, i;
	static	union	REGS	r;

	koniec = 1;
	if(sstat & LC0_IS_END_ADC)
	  {
	  r.x.dx = FP_SEG(&s_analog_in);
	  r.x.di = FP_OFF(&s_analog_in);
	  int86(LCinterrupt, &r, &r);	/* ANALOG INPUT - funkcja MUSI !!! */
					/* byc wywolana w obsludze         */
					/* przerwania z modulu             */
	  sound(ATONE);
	  for(i = 0; i < 64000L; i++)
	     a = i;
	  nosound();
	  }
	return;
}


/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wykonanie asynchronicznej transmisji blokowej.                        */
/*   Na zmiane do dwu buforow.                                             */
/* Sposob:                                                                 */
/*   Przez wykonanie funkcji ANALOG_INPUT.                                 */
/* Parametry:                                                              */
/* Wartosc:                                                                */
/* Uwagi:                                                                  */
/***************************************************************************/
void asynchrtransmission1(void)
{
	unsigned int 	seg, last;
	int far  	*Buffer_to_free;
	int	huge *curr_buf;
	int	huge *calc_buf;


	bufnum = 0;
	if((buf1 = (int huge *)farmalloc(2*BUFLEN1 * sizeof(int))) == NULL)
	  {
	  printf("BLAD - brak pamieci");
	  return;
	  }
	Buffer_to_free = (int far *)buf1;
	seg = FP_SEG((int far *)buf1) + 1;
	last = seg + (BUFLEN1 * sizeof(int)) / 16;
	if((seg & 0xf000) != (last & 0xf000)) {
	  buf1 = (int huge *)MK_FP((last & 0xf000), 0);
	  buf2 = (int huge *)buf1 + SAMPLES * CHANNELS * sizeof(int);
	}

			/* wyinstalowanie obslugi przerwania z modulu */
	s_interr.LC0_SMODULE = 1;
	s_interr.LC0_SPROC = NULL;
	sstat = 0;
	s_interr.LC0_SSTAT = &sstat;
	r.x.dx = FP_SEG(&s_interr);
	r.x.di = FP_OFF(&s_interr);
	int86(LCinterrupt, &r, &r);

			/* zainstalowanie obslugi przerwania z modulu */
	s_interr.LC0_SMODULE = 1;
	s_interr.LC0_SPROC = a1_interrupt_service;
	r.x.dx = FP_SEG(&s_interr);
	r.x.di = FP_OFF(&s_interr);
	int86(LCinterrupt, &r, &r);	/* INTERRUPT SERVICE */

	memset((void *)buf1, 0x0, SAMPLES * CHANNELS * sizeof(int));
	memset((void *)buf2, 0x0, SAMPLES * CHANNELS * sizeof(int));

	do {
		if (!bufnum) {
			curr_buf = buf1;
			calc_buf = buf2;
			memset((void *)curr_buf, 0x0, SAMPLES * CHANNELS * sizeof(int));
		} else {
			curr_buf = buf2;
			calc_buf = buf1;
			memset((void *)curr_buf, 0x0, SAMPLES * CHANNELS * sizeof(int));
		}

		s_analog_in.LC0_APER = 500000L;
		clrscr();
		printf
		(
		"Pomiar blokowy, %d kanalow, %d probek, okres probkowania %.1f s:\n",
		CHANNELS, SAMPLES, (float)s_analog_in.LC0_APER / 10
		);
		printf("---- KONIEC (po zapelnieniu bufora) - dowolny klawisz ----\n");
		printf("\n\nPomiar do bufora nr %d;\n", bufnum + 1);
		s_analog_in.LC0_AMODULE = modulenum;
		s_analog_in.LC0_ANUM = 1;
		s_analog_in.LC0_AMODE = LC0_MOD_START |
				      LC0_MOD_NEW_PAR |
				      LC0_MOD_INTR |
				      LC0_MOD_BLOCK;
				/* stop po zmierzeniu okreslonej liczby probek     */
		s_analog_in.LC0_ASTST = LC0_ZSAMPLES;
					/* praca wielokanalowa, CHANNELS kanalow   */
		s_analog_in.LC0_ACHAN = CHANNELS;

		s_analog_in.LC0_AADDR = (int far *)curr_buf;/* konieczna konwersja na  */
							/*   daleki adres          */
		s_analog_in.LC0_ALEN = SAMPLES * CHANNELS * sizeof(int);	/* dlugosc bufora                  */

		s_analog_in.LC0_ABMAR = 0;
		s_analog_in.LC0_AEMAR = 0;	/* oba marginesy zerowe            */
						/* calkowita liczba probek         */
		s_analog_in.LC0_ASTOP.samples = SAMPLES * CHANNELS;
		r.x.dx = FP_SEG(&s_analog_in);
		r.x.di = FP_OFF(&s_analog_in);
		int86(LCinterrupt, &r, &r);			/* ANALOG_INPUT    */
		koniec = 0;
		do
			performcalc((int *)calc_buf, CHANNELS, SAMPLES);
		while(!koniec);
		koniec = 0;

	} while(!kbhit());

	pressanykey();
	farfree(Buffer_to_free);
  	
} 	

/****************************************************************************/
/* Przeznaczenie:                                                           */
/*   Obsluga przerwania przychodzacego z modulu po zmierzeniu bloku         */
/*   probek - praca asynchroniczna z przerwaniem na koniec bloku, dwa bufory*/
/* Sposob:                                                                  */
/* Parametry:                                                               */
/* Wartosc:                                                                 */
/* Uwagi:                                                                   */
/****************************************************************************/
void a1_interrupt_service(void)
{
	static	union	REGS	r;

	koniec = 1;
	bufnum = !bufnum;
	if(sstat & LC0_IS_END_ADC)
	  {
	  r.x.dx = FP_SEG(&s_analog_in);
	  r.x.di = FP_OFF(&s_analog_in);
	  int86(LCinterrupt, &r, &r);	/* ANALOG INPUT - funkcja MUSI !!! */
					/* byc wywolana w obsludze         */
	  }			/* przerwania z modulu             */
	return;
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Cykliczne wykonywanie asynchronicznej transmisji blokowej.            */
/* Sposob:                                                                 */
/*   Przez wykonanie funkcji ANALOG_INPUT.                                 */
/* Parametry:                                                              */
/*   start - typ warunku startu                                            */
/* Wartosc:                                                                */
/* Uwagi:                                                                  */
/***************************************************************************/
void cycletransmission(void)
{

	unsigned int 	seg, last;
	int far  	*Buffer_to_free;


	if((buf1 = (int huge *)farmalloc(2*BUFLEN1 * sizeof(int))) == NULL)
	  {
	  printf("BLAD - brak pamieci");
	  return;
	  }
	Buffer_to_free = (int far *)buf1;
	seg = FP_SEG((int far *)buf1) + 1;
	last = seg + (BUFLEN1 * sizeof(int)) / 16;
	if((seg & 0xf000) != (last & 0xf000))
	    buf1 = (int huge *)MK_FP((last & 0xf000), 0);

			/* wyinstalowanie obslugi przerwania z modulu */
	s_interr.LC0_SMODULE = 1;
	s_interr.LC0_SPROC = NULL;
	sstat = 0;
	s_interr.LC0_SSTAT = &sstat;
	r.x.dx = FP_SEG(&s_interr);
	r.x.di = FP_OFF(&s_interr);
	int86(LCinterrupt, &r, &r);
			/* zainstalowanie obslugi przerwania z modulu */

	s_interr.LC0_SMODULE = 1;
	s_interr.LC0_SPROC = c_interrupt_service;
	r.x.dx = FP_SEG(&s_interr);
	r.x.di = FP_OFF(&s_interr);
	int86(LCinterrupt, &r, &r);

	memset((void *)buf1, 0, BUFLEN * sizeof(int));
	s_analog_in.LC0_APER = 2500000L;
	printf
	(
	"Pomiar blokowy, %d kanalow, %d probek, okres probkowania %.1f s:\n",
	CHANNELS, SAMPLES, (float)s_analog_in.LC0_APER / 10
	);
	printf("---- praca z buforem cyklicznym; KONIEC - Ctrl-Break ----");
	s_analog_in.LC0_AMODULE = modulenum;
	s_analog_in.LC0_ANUM = 1;
	s_analog_in.LC0_AMODE = LC0_MOD_START |
			      LC0_MOD_NEW_PAR |
			      LC0_MOD_INTR |
					LC0_MOD_BLOCK |
					LC0_MOD_CYCL;
			/* stop po zmierzeniu okreslonej liczby probek     */
	s_analog_in.LC0_ASTST = LC0_ZSAMPLES;
				/* praca wielokanalowa, CHANNELS kanalow   */
	s_analog_in.LC0_ACHAN = CHANNELS;
	s_analog_in.LC0_AADDR = (int far *)buf1;	/* konieczna konwersja na  */
						/*   daleki adres          */
	s_analog_in.LC0_ALEN = BUFLEN;	/* dlugosc bufora                  */
	s_analog_in.LC0_ABMAR = 0;
	s_analog_in.LC0_AEMAR = 0;	/* oba marginesy zerowe            */
					/* calkowita liczba probek         */
	s_analog_in.LC0_ASTOP.samples = SAMPLES * CHANNELS;
	r.x.dx = FP_SEG(&s_analog_in);
	r.x.di = FP_OFF(&s_analog_in);
	int86(LCinterrupt, &r, &r);			/* ANALOG_INPUT    */
	koniec = 0;
	while(!koniec)
	  displaybuf((int *)buf1, CHANNELS, SAMPLES);
	koniec = 0;
	pressanykey();
	farfree(Buffer_to_free);
}

/****************************************************************************/
/* Przeznaczenie:                                                           */
/*   Obsluga przerwania przychodzacego z modulu po zmierzeniu bloku         */
/*   probek - praca asynchroniczna z buforem cyklicznym z przerwaniem na    */
/*   koniec bloku                                                           */
/* Sposob:                                                                  */
/* Parametry:                                                               */
/* Wartosc:                                                                 */
/* Uwagi:                                                                   */
/****************************************************************************/
void c_interrupt_service(void)
{
	static union	REGS	r;

	if(sstat & LC0_IS_END_ADC)
	  {
	  r.x.dx = FP_SEG(&s_analog_in);
	  r.x.di = FP_OFF(&s_analog_in);
	  memset((void *)buf1, 0, BUFLEN * sizeof(int));
	  int86(LCinterrupt, &r, &r);	/* ANALOG INPUT - funkcja MUSI !!! */
	  }                             /* byc wywolana w obsludze         */
					/* przerwania z modulu             */
	return;
}
